package com.gic.spark.tag;

import com.gic.spark.filter.*;
import com.gic.spark.util.DingtalkMessageUtil;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/5/13
 */
public class TagFilterFactory {

    private static TagFilterFactory instance;

    public static TagFilterFactory getInstance() {
        if(null==instance){
            instance=new TagFilterFactory();
        }
        return instance;
    }
    private TagFilterFactory(){}

    public TagFilter getTagFilter(String tagEsFieldName){
        TagFilter tagFilter=null;
        switch (tagEsFieldName) {
            //积分信息
            case TagConstant.TAG_CODE_ACCUMULATED_INTEGRAL:
                tagFilter= TagAccumulatedIntegralFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_ABOUT_EXPIRE_INTEGRAL:
                tagFilter= TagAboutExpireIntegralFilter.getInstance();
                break;


            //卡卷类
            case TagConstant.TAG_CODE_CURRENT_COUPON_NUM:
                tagFilter= TagCurrentCouponNumFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_UNCLAIMED_COUPON:
                tagFilter= TagCouponFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_GET_NO_CANCEL_COUPON:
                tagFilter= TagCouponFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_NO_CANCEL_EXPIRES_COUPON:
                tagFilter= TagCouponFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_CANCEL_COUPON:
                tagFilter=TagCouponFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_DONATION_IN_COUPON:
                tagFilter=TagCouponFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_YET_DONATION_COUPON:
                tagFilter=TagCouponFilter.getInstance();
                break;


            //消费统计
            case TagConstant.TAG_CODE_CONSUMPTION_TIME:
                tagFilter=TagConsumptionTimeFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_PER_CUSTOMER_TRANSACTION:
                tagFilter=TagPerCustomerTransactionFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_ASSOCIATED_PURCHASE_RATE:
                tagFilter=TagAssociatedPurchaseRateFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_AVERAGE_DISCOUNT_FACTOR:
                tagFilter=TagAverageDiscountFactorFilter.getInstance();
                break;
            case TagConstant.TAG_CODE_CONSUMPTION_SLEEP_DAYS:
                tagFilter=TagConsumptionSleepDaysFilter.getInstance();
                break;
            default:
                DingtalkMessageUtil.sendAlertMessage("暂未支持的非实时标签: " + tagEsFieldName);
                break;
        }
        return tagFilter;
    }
}
